Debian Bug report logs - #712156
[mumble] Alternate OpenGL overlay solution

version graph

Package: mumble; Maintainer for mumble is Christopher Knadle <Chris.Knadle@coredump.us>; Source for mumble is src:mumble.

Reported by: Chris.Knadle@coredump.us

Date: Thu, 13 Jun 2013 15:54:02 UTC

Severity: wishlist

Found in version mumble/1.2.3-349-g315b5f5-2.2

Fixed in version mumble/1.2.4-0.1

Done: Christopher Knadle <Chris.Knadle@coredump.us>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Ron Lee <ron@debian.org>:
Bug#712156; Package mumble. (Thu, 13 Jun 2013 15:54:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Chris.Knadle@coredump.us:
New Bug report received and forwarded. Copy sent to Ron Lee <ron@debian.org>. (Thu, 13 Jun 2013 15:54:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Chris Knadle <Chris.Knadle@coredump.us>
To: submit@bugs.debian.org
Subject: [mumble] Alternate OpenGL overlay solution
Date: Thu, 13 Jun 2013 11:22:54 -0400
Package: mumble
Version: 1.2.3-349-g315b5f5-2.2
Severity: wishlist

--- Please enter the report below this line. ---

Ron --

Mumble upstream replied to a bug I submitted to them concerning the OpenGL bug 
that was dealt with in #691535 and after investigating they came up with a 
different solution.


-----------------------------------------------------------------

libmumble.so as built fresh from Git is meant to work without
being linked to libGL. It overrides glXSwapBuffers (via traditional
LD_PRELOAD or by hooking into dlopen/dlsym), and will only ever
call OpenGL functions in the glXSwapBuffers call -- so OpenGL
functions will only be invoked if the process by some means
has loaded libGL (or equivalent) anyway.

This is the way it has worked for a long time.

While looking into this, I also found out why it doesn't work
that way for Debian anymore. The reason is that the rules file
sets DEB_BUILD_HARDENING=1 which, among other things, causes all
built binaries to be linked with "-z now". This causes all dynamic
symbols to resolved when the program is loaded.

In our normal build, we use "-z now" for all binaries and shared
libraries, except libmumble.so -- because we want the behavior
of a lightweight LD_PRELOADable library I described above.

I have updated the debian/rules file in our Ubuntu PPA with a fix
for this:

https://github.com/mumble-voip/mumble-ubuntu-
ppa/commit/8756933f3a18cec4f24ca885d5c33118cc10bddf

I set DEB_BUILD_HARDENING_BINDNOW=0, and let the Mumble build link
using "-z now" for the binaries it knows are OK with having load-time
symbol resolving.

Regarding the current Debian fix of linking directly with libGL,
I don't see too much harm. The Linux overlay only supports GLX
at present, so direct linking doesn't hurt in that regard. But
were the overlay to support a non-GLX OpenGL implementation in
the future, alongside the current GLX support, direct linking
probably wouldn't work out favourably.

Our preferred method however is still the lightweight LD_PRELOAD-able
overlay library which only links against libc and friends. That
way, we don't potentially bring in unwanted dependencies with us
when we're LD_PRELOADED into foreign programs, and we let the
environment of the foreign program guide our decisions.



Reply sent to Christopher Knadle <Chris.Knadle@coredump.us>:
You have taken responsibility. (Mon, 25 Nov 2013 11:39:10 GMT) Full text and rfc822 format available.

Notification sent to Chris.Knadle@coredump.us:
Bug acknowledged by developer. (Mon, 25 Nov 2013 11:39:10 GMT) Full text and rfc822 format available.

Message #10 received at 712156-close@bugs.debian.org (full text, mbox):

From: Christopher Knadle <Chris.Knadle@coredump.us>
To: 712156-close@bugs.debian.org
Subject: Bug#712156: fixed in mumble 1.2.4-0.1
Date: Mon, 25 Nov 2013 11:35:31 +0000
Source: mumble
Source-Version: 1.2.4-0.1

We believe that the bug you reported is fixed in the latest version of
mumble, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 712156@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christopher Knadle <Chris.Knadle@coredump.us> (supplier of updated mumble package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 19 Sep 2013 14:54:31 -0400
Source: mumble
Binary: mumble mumble-server mumble-dbg
Architecture: source amd64
Version: 1.2.4-0.1
Distribution: unstable
Urgency: low
Maintainer: Ron Lee <ron@debian.org>
Changed-By: Christopher Knadle <Chris.Knadle@coredump.us>
Description: 
 mumble     - Low latency VoIP client
 mumble-dbg - Low latency VoIP client (debugging symbols)
 mumble-server - Low latency VoIP server
Closes: 706053 712156 726860 728545
Changes: 
 mumble (1.2.4-0.1) unstable; urgency=low
 .
   * Non-maintainer upload.
   * New (stable upstream) version from 2013-06-01  Closes: #728545
   * Standards-Version: update to 3.9.4 (no changes needed)
   * debian/control:
       - Switch from zeroc-ice34 to zeroc-ice35
         Closes: #726860
       - Remove g++-4.6 dependency
   * debian/patches:
       - Remove deprecated quilt patches:
           10-use-celt-guard
           15-fix-noise-in-opus-mode
           20-add-opus-threshold-option
           25-add-codec-warnings
           30-opengl
       - Refresh patch 02-reject-with-ip-in-log.diff, add DEP3 headers
       - Update 05-lsb-description.diff to add DEP3 headers
       - Add 06-connect-dialog-hang-dee463ef.diff patch from Ubuntu PPA
       - Refresh patch 07-use-embedded-celt-baseline, rename with .diff,
         add DEP3 headers
       - Add 09-register-mumble-URL-handler.diff  Closes: #706053
   * debian/rules:
       - Remove g++-4.6 hardcoding
       - Add DEB_BUILD_HARDENING_BINDNOW=0, upstream's suggested fix
         for #691535.  Closes: #712156
       - Update 'clean' target, 'rm -rf Ice' to allow rebuilding
   * debian/mumble.install:
       - Update to ship libcelt0.so.0.7.0 only
   * Add debian/mumble-server.init script
   * Add debian/watch file to monitor
     http://mumble.info/snapshot/mumble-(*.)\.tar\.gz
Checksums-Sha1: 
 eb9795f183aeccd42eb39ef326bd38258e6a2cb1 2385 mumble_1.2.4-0.1.dsc
 a1df48f98db4f7a80efd56c9cbfe996238203c19 3200084 mumble_1.2.4.orig.tar.gz
 d7ed7d0fd962740406ad93b46738aef949edd3d5 34805 mumble_1.2.4-0.1.debian.tar.gz
 f55be52fffd4c58722f0b424664f5bb4bd7866db 2574652 mumble_1.2.4-0.1_amd64.deb
 73dba2dd3367184670e1a751f5c66221b432a05d 736058 mumble-server_1.2.4-0.1_amd64.deb
 435e8a6d4d7b46ea9cb63f17f7957d625b918ee3 14874514 mumble-dbg_1.2.4-0.1_amd64.deb
Checksums-Sha256: 
 dca97912c5ca72ca608c7d9072f520db1c9d743a10fc049d46deb5c4ec0bd37f 2385 mumble_1.2.4-0.1.dsc
 a1cf8383d99a02719b16c5440e3a5fb5375a8aa060f203bfa5d25bc69f919c9b 3200084 mumble_1.2.4.orig.tar.gz
 394e1960cad3e0bc9177e74ae6dbe226f721cd966f6064c8c5b05d875b9cac20 34805 mumble_1.2.4-0.1.debian.tar.gz
 3bfb1a22662d20765090ddd02c3490942ebd87e90d0fc08bd359ded3d499c6a7 2574652 mumble_1.2.4-0.1_amd64.deb
 2c88a0bc27b60474a1cedf1d197f522743525ad1baae3f6948ff1da616f396ef 736058 mumble-server_1.2.4-0.1_amd64.deb
 c593f3fbbb4781e98c68e194cb16532f22cfebabd7ab7bb4498053ffc18d2d5b 14874514 mumble-dbg_1.2.4-0.1_amd64.deb
Files: 
 7ee1575b5f86ba797d0866f908b9d7ef 2385 sound optional mumble_1.2.4-0.1.dsc
 49bc6abea78f9c54298934c2c28a7c7c 3200084 sound optional mumble_1.2.4.orig.tar.gz
 f9823a38a5907105746a7d09f80d735a 34805 sound optional mumble_1.2.4-0.1.debian.tar.gz
 aaae39ee11eadd105ac8167e40f039f3 2574652 sound optional mumble_1.2.4-0.1_amd64.deb
 a468acbceba9d8b175cf44d370af9b25 736058 sound optional mumble-server_1.2.4-0.1_amd64.deb
 dd4b11ea76a13fa29f4bdd168ac404f6 14874514 debug extra mumble-dbg_1.2.4-0.1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJSjJW7AAoJEBLZsEqQy9jk80wP/RT/Bw7SCu7H9MKPeRI79nKK
GhEnivzPqP+V39G+lrsate2kt6RXIONuzBR+ykVCZnOGSGwfrUWIOavBz2DOTq7u
InNN022Oh2pPc+KlNj40ukaVLGTkTh7oU9QtC/l19PJZKC1ny+ARPHCJqXrUCCZL
bP6JXDb8473l6EXdY6XGaXbfN21L9un5c2/UqCwnW0WjphSLsCaxGZ/Wq62JX1of
GjuJhusFVAy5Th7ebs3wyt/bLoythcdUIJUKxdZOzfaa8XDWrHx/YB5nmaWxw9Ws
3DNhO7P3qxdt3BjjcXY42RRpqMKVty9crHXPr/eu66N7CkayZspETpqNyPcDoHkk
ZIH8CyeqwIxWobNG7A+p0gF6giRWBuWFUvgBHOmfuBJr/Uj0F8bjoOvDqtqjn7OU
/IuspalQ2XajU5P43F346V9Viw+EVtCWVJQO4f364mzMbPas+d3AWVN0Yt0RuRx9
Fy+XzPLJe8eM/InwYEIYYceL16YhbHPlYxyW2AYBEg4ukifgY6FJho1jrv03xnXg
W8KDxcHlzYrCYv4UjTpHbiW0spsdoWEGivWaQfqsazfAzRMWrGVDae1/564o2vie
SHBDPtUi+vPyhdCobDB5gVd6sxKy8X/rytVPodPkYACX1T3IZWUahOAXczkmsn5a
K7mzKvGdKEdWd2Rlbwf7
=qy+f
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 28 Feb 2014 07:32:24 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 03:57:41 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.